Bug 841746 - Review Request: ghc-arrows - Classes that extend the Arrow class
Review Request: ghc-arrows - Classes that extend the Arrow class
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Narasimhan
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-07-20 02:48 EDT by Shakthi Kannan
Modified: 2012-10-28 23:36 EDT (History)
4 users (show)

See Also:
Fixed In Version: ghc-arrows-0.4.4.0-1.fc17
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-10-28 23:36:14 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
lakshminaras2002: fedora‑review+
tibbs: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Shakthi Kannan 2012-07-20 02:48:12 EDT
Spec URL: http://shakthimaan.fedorapeople.org/SPECS/ghc-arrows.spec
SRPM URL: http://shakthimaan.fedorapeople.org/SRPMS/ghc-arrows-0.4.4.0-1.fc16.src.rpm
Description: Several classes that extend the Arrow class, and some transformers that implement or lift these classes.
Fedora Account System Username: shakthimaan
Comment 1 Shakthi Kannan 2012-07-20 02:50:07 EDT
$ rpmlint ghc-arrows.spec
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

$ rpmlint ghc-arrows-0.4.4.0-1.fc16.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

$ rpmlint ghc-arrows-0.4.4.0-1.fc16.x86_64.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

$ rpmlint ghc-arrows-devel-0.4.4.0-1.fc16.x86_64.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

Successful Koji builds for F16, F17 and F18 respectively:

http://koji.fedoraproject.org/koji/taskinfo?taskID=4274656
http://koji.fedoraproject.org/koji/taskinfo?taskID=4274659
http://koji.fedoraproject.org/koji/taskinfo?taskID=4274660
Comment 2 Narasimhan 2012-10-08 07:41:59 EDT
[+]MUST: rpmlint must be run on every package. The output should be posted in the review.
 rpmlint -i ghc-arrows-0.4.4.0-1.fc17.src.rpm ghc-arrows-0.4.4.0-1.fc17.x86_64.rpm ghc-arrows-devel-0.4.4.0-1.fc17.x86_64.rpm ../ghc-arrows.spec 
3 packages and 1 specfiles checked; 0 errors, 0 warnings.

[+]MUST: The package must be named according to the Package Naming Guidelines.
[+]MUST: The spec file name must match the base package %{name}, in the format %{name}.spec
[+]MUST: The package must meet the Packaging Guidelines.
        Naming-Yes
        Version-release - Matches
        License - OK
        No prebuilt external bits - OK
        Spec legibity - OK
        Package template - OK
        Arch support - OK
        Libexecdir - OK
        rpmlint - yes
        changelogs - OK
        Source url tag  - OK, validated.
        Build Requires list - OK
        Summary and description - OK
        API documentation - OK, in devel package

[+]MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
[+]MUST: The License field in the package spec file must match the actual license.
License is BSD.
[+]MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+]MUST: The spec file must be written in American English.
[+]MUST: The spec file for the package MUST be legible.
[+]MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
sha256sum arrows-0.4.4.0.tar.gz ghc-arrows-0.4.4.0-1.fc16.src/arrows-0.4.4.0.tar.gz 
4999ba909061f5bede09e6116e2cac1cf89f04d3429a4a2be6ef79a677d89bb5  arrows-0.4.4.0.tar.gz
4999ba909061f5bede09e6116e2cac1cf89f04d3429a4a2be6ef79a677d89bb5  ghc-arrows-0.4.4.0-1.fc16.src/arrows-0.4.4.0.tar.gz
[+]MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[+]MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch.
[+]MUST: All build dependencies must be listed in BuildRequires.
[+]MUST: Packages must NOT bundle copies of system libraries.
Checked with rpmquery --list
[+]MUST: A package must own all directories that it creates.
Checked with rpmquery --whatprovides
[+]MUST: A Fedora package must not list a file more than once in the spec file's %files listings.
[+]MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.
[+]MUST: Each package must consistently use macros.
[+]MUST: devel packages must require the base package using a fully versioned dependency: Requires: {name} = %{version}-%{release}
        ghc(arrows-0.4.4.0) = c871892887d8c9a8a81b6aba26d0627c is needed by (installed) ghc-arrows-devel-0.4.4.0-1.fc17.x86_64
        ghc-arrows = 0.4.4.0-1.fc17 is needed by (installed) ghc-arrows-devel-0.4.4.0-1.fc17.x86_64
[+]MUST: Packages must not own files or directories already owned by other packages.
[+]MUST: All filenames in rpm packages must be valid UTF-8.

Should items
[+]SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. 
[+]SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
Installed the packages. Loaded Control.Arrow.Transformer into ghci. Loads fine.
[+]SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.

cabal2spec-diff is OK.

APPROVED.
Comment 3 Narasimhan 2012-10-08 07:46:07 EDT
Output from fedora-review

Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
[!]: Static libraries in -static subpackage, if present.
     Note: ghc-arrows-devel-0.4.4.0-1.fc17.x86_64.rpm :
     /usr/lib64/ghc-7.0.4/arrows-0.4.4.0/libHSarrows-0.4.4.0.a ghc-arrows-
     devel-0.4.4.0-1.fc17.x86_64.rpm :
     /usr/lib64/ghc-7.0.4/arrows-0.4.4.0/libHSarrows-0.4.4.0_p.a
See: http://fedoraproject.org/wiki/Packaging/Guidelines#StaticLibraries
[!]: Package does not contain duplicates in %files.
     Note: warning: File listed twice: /usr/share/doc/ghc-arrows-0.4.4.0
See: http://fedoraproject.org/wiki/Packaging/Guidelines#DuplicateFiles
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. No licenses
     found. Please check the source files for licenses manually.
See: http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#ValidLicenseShortNames


===== MUST items =====

C/C++:
[x]: Package does not contain any libtool archives (.la)
[ ]: Package does not contain kernel modules.
[ ]: Package contains no static executables.
[x]: Rpath absent or only used for internal libs.
[ ]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[!]: Static libraries in -static subpackage, if present.
     Note: ghc-arrows-devel-0.4.4.0-1.fc17.x86_64.rpm :
     /usr/lib64/ghc-7.0.4/arrows-0.4.4.0/libHSarrows-0.4.4.0.a ghc-arrows-
     devel-0.4.4.0-1.fc17.x86_64.rpm :
     /usr/lib64/ghc-7.0.4/arrows-0.4.4.0/libHSarrows-0.4.4.0_p.a

Generic:
[ ]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[ ]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[ ]: Package contains no bundled libraries.
[ ]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[ ]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
[ ]: Macros in Summary, %description expandable at SRPM build time.
[ ]: Package contains desktop file if it is a GUI application.
[ ]: Development files must be in a -devel package
[ ]: Package requires other packages for directories it uses.
[ ]: Package uses nothing in %doc for runtime.
[ ]: Package is not known to require ExcludeArch.
[!]: Package does not contain duplicates in %files.
     Note: warning: File listed twice: /usr/share/doc/ghc-arrows-0.4.4.0
[x]: Permissions on files are set properly.
[ ]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[ ]: Large documentation files are in a -doc subpackage, if required.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. No licenses
     found. Please check the source files for licenses manually.
[ ]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named using only allowed ASCII characters.
[ ]: Package is named according to the Package Naming Guidelines.
[ ]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[ ]: Package obeys FHS, except libexecdir and /usr/target.
[ ]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[ ]: Package must own all directories that it creates.
[ ]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[ ]: Package is not relocatable.
[ ]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[ ]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[ ]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[ ]: Useful -debuginfo package or justification otherwise.

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[ ]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[ ]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[ ]: Package functions as described.
[ ]: Latest version is packaged.
[ ]: Package does not include license text files separate from upstream.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[!]: SourceX / PatchY prefixed with %{name}.
     Note: Source0 (arrows-0.4.4.0.tar.gz)
[x]: SourceX is a working URL.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: ghc-arrows-0.4.4.0-1.fc17.x86_64.rpm
          ghc-arrows-devel-0.4.4.0-1.fc17.x86_64.rpm
          ghc-arrows-0.4.4.0-1.fc17.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.


Rpmlint (installed packages)
----------------------------
# rpmlint ghc-arrows ghc-arrows-devel
2 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'


Unversioned so-files
--------------------
ghc-arrows-0.4.4.0-1.fc17.x86_64.rpm: /usr/lib64/ghc-7.0.4/arrows-0.4.4.0/libHSarrows-0.4.4.0-ghc7.0.4.so

MD5-sum check
-------------
http://hackage.haskell.org/packages/archive/arrows/0.4.4.0/arrows-0.4.4.0.tar.gz :
  CHECKSUM(SHA256) this package     : 4999ba909061f5bede09e6116e2cac1cf89f04d3429a4a2be6ef79a677d89bb5
  CHECKSUM(SHA256) upstream package : 4999ba909061f5bede09e6116e2cac1cf89f04d3429a4a2be6ef79a677d89bb5

Built with local dependencies:


Generated by fedora-review 0.3.0 (c78e275) last change: 2012-09-24
Buildroot used: fedora-17-x86_64
Command line :/bin/fedora-review -n ghc-arrows -L ghc-arrows
Comment 4 Shakthi Kannan 2012-10-08 08:28:00 EDT
Thanks for the review.

New Package SCM Request
=======================
Package Name: ghc-arrows
Short Description: Classes that extend the Arrow class
Owners: shakthimaan
Branches: f17 f18
InitialCC: haskell-sig
Comment 5 Jason Tibbitts 2012-10-08 12:22:44 EDT
Git done (by process-git-requests).
Comment 6 Fedora Update System 2012-10-09 01:43:01 EDT
ghc-arrows-0.4.4.0-1.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/ghc-arrows-0.4.4.0-1.fc17
Comment 7 Fedora Update System 2012-10-09 01:43:15 EDT
ghc-arrows-0.4.4.0-1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/ghc-arrows-0.4.4.0-1.fc18
Comment 8 Fedora Update System 2012-10-09 13:22:26 EDT
ghc-arrows-0.4.4.0-1.fc18 has been pushed to the Fedora 18 testing repository.

Note You need to log in before you can comment on or make changes to this bug.